LiveForm.setOptions({
    messageTag: 'p',
    messageErrorClass: 'mdc-text-field-helper-text mdc-text-field-helper-text--persistent mdc-text-field-helper-text--validation-msg live-form-error',
    messageErrorPrefix: '',
    messageParentClass: 'input-parent'
});

function checkTextInputRequired(data)
{
    if(data.data !== undefined)
    {
        data = data.data;
    }
    var required = false;
    var elem = data.input;
    var rules = Nette.parseJSON(elem.getAttribute('data-nette-rules'));
    
    for (var id = 0; id < rules.length; id++) {
        var rule = rules[id];

        if(rule.op == ":filled")
        {
            required = true;
            break;
        }

        //only one level
        if(rule.control && rule.rules.length > 0)
        {
            var mayBeRequired = false;
            for(var innerId = 0; innerId < rule.rules.length; innerId++)
            {
                var innerRule = rule.rules[innerId];
                if(innerRule.op == ":filled")
                {
                    mayBeRequired = true;
                    break;
                }
            }

            if(mayBeRequired)
            {
                var currElem = elem.form.elements.namedItem(rule.control);
                data.watchedControls.push(currElem);

                if(Nette.validateRule(currElem, rule.op, rule.arg))
                {
                    required = true;
                }
            }
        }
    }

    $(elem).attr("required", required ? "required" : false);
}

function initRequiredTextInputs()
{
    $("input[data-nette-rules]").each(function(){
        var data = {input: this, watchedControls: []};
        checkTextInputRequired(data);

        for (var i = 0; i < data.watchedControls.length; i++) {
            $(data.watchedControls[i]).change({input: this, watchedControls: []}, checkTextInputRequired);
        }
    });
}

function initAutocomplete()
{
    $("input[data-autocomplete-url]").each(function(){
        $(this).autocomplete({
            serviceUrl: $(this).data('autocomplete-url')
        });
    });
}

$(document).ready(function(){
    $.nette.init();
    initRequiredTextInputs();
    initAutocomplete();
    window.mdc.autoInit();
});